local drawBridge = ...

drawBridge:registerAssetProcessor("models/drawBridges/drawBridgeA.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
drawBridge:registerAssetProcessor("models/drawBridges/drawBridgeB.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
drawBridge:registerAssetProcessor("models/drawBridges/harrow.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

--------------------------------------------------------------------------

-- Register IDs for all prefab nodes referenced here
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/sgv5dba_CenterPart", "STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeB.fbx/Prefab/drawBridge/sgv5dbb_CenterPart", "STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/RootPart", "STONE_GATE_V5_DRAW_BRIDGE_CENTER_ROOT_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartSlopePart", "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_START_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndSlopePart", "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_END_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartPart", "STONE_GATE_V5_DRAW_BRIDGE_START_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndPart", "STONE_GATE_V5_DRAW_BRIDGE_END_PREFAB")
drawBridge:registerAssetId("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/TilingPart", "STONE_GATE_V5_DRAW_BRIDGE_TILING_PREFAB")
drawBridge:registerAssetId("models/drawBridges/harrow.fbx/Prefab/drawBridge/HarrowPart", "STONE_GATE_V5_DRAW_BRIDGE_HARROW_PREFAB")

--------------------------------------------------------------------------

-- Register bridge tiling (the pillar part that extends to the ground)
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_TILING_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_TILING_PREFAB"
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 1 }
		}
	},
})

-- Register bridge start part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_START_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BASEMENT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_START_PREFAB",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 2 }
		},
	},
})

-- Register bridge end part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_END_PART",
	Mover = { DataType = "BUILDING_PART_MOVER_BRIDGE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BASEMENT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_END_PREFAB",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 2 }
		},
	},
})

-- Register bridge start slope part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_START_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BASEMENT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_START_PREFAB",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 1 }
		},
	},
})

-- Register bridge end slope part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_END_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BASEMENT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_SLOPE_END_PREFAB",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 1 }
		},
	},
})

-- Register bridge center A top part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_TOP_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_PREFAB"
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "TOOL", Quantity = 2 },
			{ Resource = "PLANK", Quantity = 10 }
		},
	},
})

-- Register bridge center B top part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_TOP_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_PREFAB"
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "TOOL", Quantity = 2 },
			{ Resource = "PLANK", Quantity = 10 }
		},
	},
})

-- Register the center root A part (the scalable part that places multiple center top parts)
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_CORE_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_CENTER_ROOT_PREFAB",
		EndPart = "STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_TOP_PART",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 1 }
		},
	},
})

-- Register the center root B part (the scalable part that places multiple center top parts)
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_CORE_PART",
	Mover = { DataType = "BUILDING_PART_MOVER" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_CENTER_ROOT_PREFAB",
		EndPart = "STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_TOP_PART",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_TILING_PART"
		},
		BasementScale = 2,
	},
	Cost = {
		DataType = "BUILDING_PART_COST",
		RessourcesNeeded = {
			{ Resource = "PLANK", Quantity = 1 }
		},
	},
})

-- Register the core A part (the part with the bridge mover)
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_A_CORE_PART",
	Name = "STONE_GATE_V5_DRAW_BRIDGE_A_CORE_NAME",
	Mover = { DataType = "BUILDING_PART_MOVER_BRIDGE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BRIDGE",
		StartPart = "STONE_GATE_V5_DRAW_BRIDGE_START_PART",
		EndPart = "STONE_GATE_V5_DRAW_BRIDGE_END_PART",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_A_CENTER_CORE_PART"
		},
		SlopeFillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_SLOPE_END_PART"
		},
		SlopeStartFillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_SLOPE_START_PART"
		},
		MinimumScale = 1,
	},
	AssetBuildingFunction = "STONE_GATE_V5_DRAW_BRIDGE_FUNCTION"
})
drawBridge:register({
		DataType = "BUILDING_FUNCTION_BRIDGE",
                Id = "STONE_GATE_V5_DRAW_BRIDGE_FUNCTION"
})


-- Register the core B part (the part with the bridge mover)
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_B_CORE_PART",
	Name = "STONE_GATE_V5_DRAW_BRIDGE_B_CORE_NAME",
	Mover = { DataType = "BUILDING_PART_MOVER_BRIDGE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_BRIDGE",
		StartPart = "STONE_GATE_V5_DRAW_BRIDGE_START_PART",
		EndPart = "STONE_GATE_V5_DRAW_BRIDGE_END_PART",
		FillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_B_CENTER_CORE_PART"
		},
		SlopeFillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_SLOPE_END_PART"
		},
		SlopeStartFillerList = {
			"STONE_GATE_V5_DRAW_BRIDGE_SLOPE_START_PART"
		},
		MinimumScale = 1,
	},
	AssetBuildingFunction = "STONE_GATE_V5_DRAW_BRIDGE_FUNCTION"
})

-- Register the additional harrow part
drawBridge:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V5_DRAW_BRIDGE_HARROW_PART",
	Name = "STONE_GATE_V5_DRAW_BRIDGE_HARROW_NAME",
	Description = "STONE_GATE_V5_DRAW_BRIDGE_HARROW_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V5_DRAW_BRIDGE_HARROW_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
    })


--------------------------------------------------------------------------

-- Override building part components properties (generated by the building asset processor) to add building zones

drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/sgv5dba_CenterPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeB.fbx/Prefab/drawBridge/sgv5dbb_CenterPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartSlopePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndSlopePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 2 }
})
drawBridge:registerPrefabComponent("models/drawBridges/harrow.fbx/Prefab/drawBridge/HarrowPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = false,
	BuildingZone = { 0, 0 }
})

--------------------------------------------------------------------------

-- Configure all BRIDGE colliders

drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/sgv5dba_CenterPart", { "BRIDGE" })
drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeB.fbx/Prefab/drawBridge/sgv5dbb_CenterPart", { "BRIDGE" })
drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartPart", { "BRIDGE" })
drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndPart", { "BRIDGE" })
drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/StartSlopePart", { "BRIDGE" })
drawBridge:configurePrefabFlagList("models/drawBridges/drawBridgeA.fbx/Prefab/drawBridge/EndSlopePart", { "BRIDGE" })
